#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1800three4xi.py">
#<abstract4xi abstract = "fires to direction three and to distance 1800"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire1800three4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2three18004xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - ) - STUBS ONLY - ALL ARE IN FILES
# -------------------------------------------------------------------------------------------------    

shot2three18004xi = {
                1:'0x1747y-432z',
                2:'0x35y-1799z',
                3:'1012x1128y-970z',
                4:'1038x1239y-790z',
                5:'103x188y-1787z',
                6:'1048x1341y-585z',
                7:'104x1507y-978z',
                8:'1050x1445y-220z',
                9:'1076x1080y-955z',
                10:'1107x1188y-774z',
                11:'111x79y-1794z',
                12:'1120x1289y-567z',
                13:'1125x1389y-202z',
                14:'1139x1028y-940z',
                15:'1173x1134y-758z',
                16:'1190x1232y-550z',
                17:'1198x1330y-184z',
                18:'1198x973y-924z',
                19:'11x88y-1797z',
                20:'122x198y-1784z',
                21:'1237x1076y-741z',
                22:'1255x915y-909z',
                23:'1257x1172y-533z',
                24:'1267x1267y-166z',
                25:'1297x1014y-725z',
                26:'129x494y-1725z',
                27:'1320x1108y-516z',
                28:'1333x1200y-148z',
                29:'1354x949y-708z',
                30:'1381x1040y-499z',
                31:'1395x1129y-130z',
                32:'141x1621y-768z',
                33:'142x206y-1782z',
                34:'1437x969y-481z',
                35:'1453x1055y-112z',
                36:'150x1458y-1208z',
                37:'160x503y-1720z',
                38:'164x212y-1779z',
                39:'17x23y-1799z',
                40:'183x1745y-397z',
                41:'184x1509y-963z',
                42:'186x217y-1777z',
                43:'192x510y-1715z',
                44:'19x105y-1796z',
                45:'1x53y-1799z',
                46:'209x220y-1774z',
                47:'20x441y-1744z',
                48:'216x1383y-1131z',
                49:'225x515y-1709z',
                50:'227x1619y-752z',
                51:'234x220y-1770z',
                52:'258x219y-1767z',
                53:'25x1500y-993z',
                54:'260x518y-1704z',
                55:'264x1506y-948z',
                56:'275x1737y-380z',
                57:'284x216y-1764z',
                58:'291x1380y-1117z',
                59:'295x518y-1698z',
                60:'29x121y-1795z',
                61:'29x36y-1799z',
                62:'309x211y-1760z',
                63:'313x1612y-735z',
                64:'331x516y-1692z',
                65:'345x1500y-932z',
                66:'365x1374y-1103z',
                67:'366x1724y-362z',
                68:'367x512y-1685z',
                69:'399x1601y-719z',
                70:'404x505y-1679z',
                71:'41x137y-1794z',
                72:'426x1488y-917z',
                73:'43x47y-1798z',
                74:'440x1363y-1088z',
                75:'441x496y-1672z',
                76:'457x1706y-344z',
                77:'45x457y-1740z',
                78:'478x484y-1666z',
                79:'484x1584y-702z',
                80:'506x1473y-901z',
                81:'515x1349y-1074z',
                82:'515x469y-1659z',
                83:'546x1683y-327z',
                84:'54x151y-1792z',
                85:'552x452y-1652z',
                86:'569x1563y-686z',
                87:'56x1619y-784z',
                88:'586x1452y-886z',
                89:'588x432y-1645z',
                90:'589x1330y-1059z',
                91:'59x57y-1798z',
                92:'5x71y-1798z',
                93:'5x8y-1799z',
                94:'624x410y-1637z',
                95:'635x1655y-309z',
                96:'652x1538y-669z',
                97:'663x1306y-1045z',
                98:'665x1428y-870z',
                99:'69x165y-1791z',
                100:'71x471y-1735z',
                101:'722x1622y-291z',
                102:'735x1279y-1030z',
                103:'735x1507y-652z',
                104:'742x1399y-854z',
                105:'75x66y-1797z',
                106:'807x1247y-1015z',
                107:'807x1585y-273z',
                108:'816x1472y-635z',
                109:'819x1365y-838z',
                110:'85x177y-1789z',
                111:'877x1211y-1000z',
                112:'890x1542y-256z',
                113:'894x1327y-822z',
                114:'895x1433y-618z',
                115:'91x1749y-415z',
                116:'93x73y-1796z',
                117:'945x1171y-985z',
                118:'967x1285y-806z',
                119:'971x1496y-238z',
                120:'972x1389y-602z',
                121:'99x483y-1730z'}
                
 
# -----------------------------------------------------------------------------------------------------------
#<function4xi function = "fire1800three4xi" usage = "target function for chargethree4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------------------------
def fire1800three4xi(queue2three, consumer_channel2three, publisher_channel2three):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE18000THREE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE18000THREE4XI -  QUEUE2THREE: ", queue2three)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE18000THREE4XI -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
        #  
              
        print("\n (STEP 1A4/33) OF FIRE18000THREE4XI -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE18000THREE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2three.put(shot2three18004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE18000THREE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE18000THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE18000THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4three = "<ack2put4xi>queue2three8shot2three18004xi</ack2put4xi>"
        else:
            message2send4three = "<nack2put4xi>queue2three<8shot2three18004xi/nack2put4xi>" 
            
        publisher_channel2three.send(message2send4three)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE18000THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE18000THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE18000THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE: ", queue2three, " - TIME: ", time4xi())  
        # 
            
    return queue2three    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1800three4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                               
                